<!DOCTYPE html>
<html>
<head>
    <!-- The '/homey.js' script must be included in your settings view to work -->
    <script
            type="text/javascript"
            src="/homey.js"
            data-origin="settings"
    ></script>
    <style>
        .inputExtra {
            width: 100%;
            border: 0;
            border-bottom: 1px solid #eaeaea;
            font-size: 16px;
            font-weight: 400;
            color: black;
            padding: 3px 0 9px 0;
        }
    </style>
</head>
<body>
<h1 data-i18n="settings.title">
    <!-- This will be filled with the translated string with key 'settings.title'. -->
</h1>
<p data-i18n="settings.subtitle">
    <!-- This field will also be translated -->
</p>

<fieldset>
    <legend>Server settings</legend>

    <div class="field row">
        <label for="server">Server</label>
        <input id="server" type="text" value="" required
               placeholder="syslog.example.com / 198.168.0.32"/>
    </div>
    <div class="field row">
        <label for="port">Port</label>
        <input id="port" type="number" value="514" class="inputExtra" required
               min="1" max="65535"/>
    </div>
    <div class="field row">
        <label for="transport">Transport</label>
        <select id="transport" name="transport" class="inputExtra" required>
            <option value="udp" selected>UDP</option>
            <option value="tcp">TCP</option>
        </select>
    </div>
</fieldset>
<fieldset>
    <legend>Client settings</legend>

    <div class="field row">
        <label for="client">Client</label>
        <input id="client" type="text" value="" required
               placeholder="homey.example.com / 198.168.0.68"/>
    </div>
    <div class="field row">
        <label for="tag">Default Tag/Program</label>
        <input id="tag" type="text" value="" required
               placeholder="homey"/>
    </div>
</fieldset>
<p>
    <button id="save" class="right">Save changes</button>
</p>


<script type="text/javascript">
    // a method named 'onHomeyReady' must be present in your code
    function onHomeyReady(Homey) {
        // Tell Homey we're ready to be displayed
        Homey.ready();

        const serverElement = document.getElementById("server");
        const portElement = document.getElementById("port");
        const transportElement = document.getElementById("transport");
        const clientElement = document.getElementById("client");
        const tagElement = document.getElementById("tag");
        const saveElement = document.getElementById("save");

        // fill fields with current settings
        Homey.get("server", function (err, server) {
            if (err) return Homey.alert(err);
            serverElement.value = server;
        });
        Homey.get("port", function (err, port) {
            if (err) return Homey.alert(err);
            portElement.value = port;
        });
        Homey.get("transport", function (err, transport) {
            if (err) return Homey.alert(err);
            transportElement.value = transport;
        });
        Homey.get("client", function (err, client) {
            if (err) return Homey.alert(err);
            clientElement.value = client;
        });
        Homey.get("tag", function (err, tag) {
            if (err) return Homey.alert(err);
            tagElement.value = tag;
        });

        // save settings on button click
        saveElement.addEventListener("click", function (e) {
            // validate input fields
            if (!validateDomain(serverElement.value.trim())) {
                return Homey.alert('Invalid server name: ' + serverElement.value);
            }
            if (!between(parseInt(portElement.value), 1, 65635)) {
                return Homey.alert('Invalid port (1-65535): ' + portElement.value);
            }
            if (!validateDomain(clientElement.value.trim())) {
                return Homey.alert('Invalid client name: ' + clientElement.value);
            }
            if (tagElement.value.trim().length > 32) {
                return Homey.alert('Tag is too long (max 32 chars): ' + tagElement.value);
            }
            if (tagElement.value.match(/[^0-9a-zA-Z]/g) !== null) {
                return Homey.alert('Tag can only contain 0-9a-zA-Z: ' + tagElement.value);
            }

            // save settings
            Homey.set("server", serverElement.value.trim(), function (err) {
                if (err) return Homey.alert(err);
            });
            Homey.set("port", portElement.value, function (err) {
                if (err) return Homey.alert(err);
            });
            Homey.set("transport", transportElement.value, function (err) {
                if (err) return Homey.alert(err);
            });
            Homey.set("client", clientElement.value, function (err) {
                if (err) return Homey.alert(err);
            });
            Homey.set("tag", tagElement.value, function (err) {
                if (err) return Homey.alert(err);
            });
        });


        function validateDomain(domain) {
            const reg = /^([a-zA-Z0-9][a-zA-Z0-9-.]{1,61}[a-zA-Z0-9](?:\.[a-zA-Z]{2,})+|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})$/;
            return reg.test(domain);
        }


        function between(x, min, max) {
            return x >= min && x <= max;
        }
    }
</script>
</body>
</html>